/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.analytics.model;

import com.google.api.client.json.GenericJson;

/**
 * JSON template for a metadata column.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Analytics API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Column extends GenericJson {

  /**
   * Map of attribute name and value for this column.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.Map<String, String> attributes;

  /**
   * Column id.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String id;

  /**
   * Resource type for Analytics column.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Map of attribute name and value for this column.
   * The value returned may be {@code null}.
   */
  public java.util.Map<String, String> getAttributes() {
    return attributes;
  }

  /**
   * Map of attribute name and value for this column.
   * The value set may be {@code null}.
   */
  public Column setAttributes(java.util.Map<String, String> attributes) {
    this.attributes = attributes;
    return this;
  }

  /**
   * Column id.
   * The value returned may be {@code null}.
   */
  public String getId() {
    return id;
  }

  /**
   * Column id.
   * The value set may be {@code null}.
   */
  public Column setId(String id) {
    this.id = id;
    return this;
  }

  /**
   * Resource type for Analytics column.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Resource type for Analytics column.
   * The value set may be {@code null}.
   */
  public Column setKind(String kind) {
    this.kind = kind;
    return this;
  }

}
