/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * Warning! This file is generated. Modify at your own risk.
 */

package com.google.api.services.analytics.model;

import com.google.api.client.json.GenericJson;

/**
 * Lists columns (dimensions and metrics) for a particular report type.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Google Analytics API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-api-java-client/wiki/Json">http://code.google.com/p/google-api-java-client/wiki/Json</a>
 * </p>
 *
 * <p>
 * Upgrade warning: starting with version 1.12 {@code getResponseHeaders()} is removed, instead use
 * {@link com.google.api.client.http.json.JsonHttpRequest#getLastResponseHeaders()}
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class Columns extends GenericJson {

  /**
   * List of attributes names returned by columns.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<String> attributeNames;

  /**
   * Etag of collection. This etag can be compared with the last response etag to check if response
   * has changed.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String etag;

  /**
   * List of columns for a report type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Column> items;

  static {
    // hack to force ProGuard to consider Column used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Column.class);
  }

  /**
   * Collection type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String kind;

  /**
   * Total number of columns returned in the response.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Integer totalResults;

  /**
   * List of attributes names returned by columns.
   * The value returned may be {@code null}.
   */
  public java.util.List<String> getAttributeNames() {
    return attributeNames;
  }

  /**
   * List of attributes names returned by columns.
   * The value set may be {@code null}.
   */
  public Columns setAttributeNames(java.util.List<String> attributeNames) {
    this.attributeNames = attributeNames;
    return this;
  }

  /**
   * Etag of collection. This etag can be compared with the last response etag to check if response
   * has changed.
   * The value returned may be {@code null}.
   */
  public String getEtag() {
    return etag;
  }

  /**
   * Etag of collection. This etag can be compared with the last response etag to check if response
   * has changed.
   * The value set may be {@code null}.
   */
  public Columns setEtag(String etag) {
    this.etag = etag;
    return this;
  }

  /**
   * List of columns for a report type.
   * The value returned may be {@code null}.
   */
  public java.util.List<Column> getItems() {
    return items;
  }

  /**
   * List of columns for a report type.
   * The value set may be {@code null}.
   */
  public Columns setItems(java.util.List<Column> items) {
    this.items = items;
    return this;
  }

  /**
   * Collection type.
   * The value returned may be {@code null}.
   */
  public String getKind() {
    return kind;
  }

  /**
   * Collection type.
   * The value set may be {@code null}.
   */
  public Columns setKind(String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Total number of columns returned in the response.
   * The value returned may be {@code null}.
   */
  public Integer getTotalResults() {
    return totalResults;
  }

  /**
   * Total number of columns returned in the response.
   * The value set may be {@code null}.
   */
  public Columns setTotalResults(Integer totalResults) {
    this.totalResults = totalResults;
    return this;
  }

}
